#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480

#define ABS(_x) ((_x) >= 0 ? (_x) : -(_x))
#define SGN(_x) ((_x) < 0 ? -1 : \
                 ((_x) > 0 ? 1 : 0))

void drawLine(int x0, int y0, int x1, int y1, Color c)
{
    int y = y0;

    int dx = x1 - x0;
    int dy = y1 - y0;
    int incX = SGN(dx);
    int incY = SGN(dy);
    int slope = 2 * ABS(dy);
    int error = -ABS(dx);
    int errorInc = -2 * ABS(dx);

    for (int x = x0; x != x1 + incX; x += incX)
    {
        gfx.setPixel(x, y, c);
        error += slope;

        if (error >= 0)
        {
            y += incY;
            error += errorInc;
        }
    }
}

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Bresenham Line 8", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    drawLine( 0, 10, 30,  0, Color(255, 0, 0));
    drawLine(30,  0, 60, 10, Color(0, 255, 0));
    drawLine(60, 10, 30, 20, Color(0, 0, 255));
    drawLine(30, 20,  0, 10, Color(255, 255, 255));

    gfx.render();

    while (sys.isQuitRequested() == false)
    {
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
